<?php
ini_set('error_log', dirname(__FILE__) . '/error_log');
ini_set('display_errors', 'off');
ini_set('log_errors', 'on');
error_reporting(E_ALL);

error_log( time() . ': ' . __FILE__ . ' startup' . PHP_EOL, 3, dirname( __FILE__ ) . '/error_log' );

set_time_limit( 360 );

if (isset($_GET['ping']) && !empty($_GET['ping'])) {
	echo 'Pong';
	exit;
}
if (get_magic_quotes_gpc()) {
	foreach (array( '_REQUEST', '_GET', '_POST' ) as $stuff) {
		$newStuff = array();
		if (isset($$stuff)) {
			foreach ($$stuff as $key => $value) {
				if (is_string($value)) {
					$newStuff[stripslashes($key)] = stripslashes($value);
				}
			}
			$$stuff = $newStuff;
		}
	}
}
@ini_set('cgi.fix_pathinfo', 1);
$installer = new Install($_POST);
exit;
/**
 * Pre Installer Payload Script
 *
 * This is called via curl. The settings are passed in the headers and the process is run
 * on the remote server.
 *
 * @subpackage Lib.assets
 *
 * @copyright SimpleScripts.com, 8 May, 2012
 **/

/**
 * Define DocBlock
 **/

class Install {

/**
 * Debug Storage
 *
 * @var array $debug
 */
	public $debug = array();

/**
 * userCounter
 *
 * @var int
 **/
	public $userCounter = 0;

/**
 * Indicates whether we're in a clean shutdown state.
 *
 * @var boolean
 */
	public $cleanShutdown = false;

/**
 * Settings
 *
 * @var array $settings
 */
	public $settings = array(
		'ss_site_url' => null,
		'ss_dbhost' => 'localhost',
		'ss_dbname' => null,
		'ss_dbpass' => null,
		'filename' => null,
		'panel_username' => null,
		'panel_password' => null,
		'panel_type' => 'other',
		'create_database' => false,
		'extract_package' => true,
	);

/**
 * Class Constructor
 *
 * The $_POST will be sent to this method and merged into the $settings defaults.
 *
 **/
	public function __construct($settings = array()) {
		if (!$settings) {
			// This is remarkably easy to find if you're into grep and kind of want to go to bed
			die("I DONT HAVE SETTINGS AAAAAAAHHHHH");
			return false;
		}

		register_shutdown_function(array($this, 'shutdown'));

		$this->debug('setup', 'Configuring settings.');
		$this->settings = array_merge($this->settings, $settings);
		$this->settings['os'] = strtolower(substr(PHP_OS, 0, 3));
		$this->settings['passthru'] = function_exists('passthru') ? true : false;
		$this->settings['root_directory'] = dirname(__FILE__);

		if (!$this->settings['filename']) {
			$this->debug('error', 'Woops! For some reason the install file name is missing.');
			$this->debug('extra', $this->settings['filename']);
			$this->errorDie();
		}

		$this->debug('setup', 'Setting full file path.');
		$this->settings['path_to_file'] = dirname(__FILE__) . '/' . $this->settings['filename'];
		$this->settings['file_ext'] = pathinfo($this->settings['filename'], PATHINFO_EXTENSION);

		$this->moveOldConfiguration();

		$this->debug('setup', 'Starting process.');

		if ($this->settings['extract_package']) {
			$this->debug('process', 'Extracting package');
			$this->extractPackage();
			$this->debug('process', 'Package extracted successfully!');
		}

		if ($this->settings['panel_type'] == 'vdeck') {
			$this->debug('process', 'Setting base PHP directives');
			$this->setPhpDirectives();
			$this->debug('process', 'Base PHP directives set');
		}

		if ($this->settings['os'] != 'win') {
			$this->debug('process', 'Setting permissions');
			$this->setPermissions();
			$this->debug('process', 'Permissions set successfully!');
		}

		$this->debug('status', 'success');
		echo json_encode($this->debug);

		$this->cleanShutdown = true;
	}

	public function shutdown() {
		if ($this->cleanShutdown) {
			return;
		}

		$error = error_get_last();

		echo json_encode(array(
			'error' => 'fatal error in ssv3_payload_extractor',
			'errorData' => $error,
			'debug' => $this->debug
		));

		return;
	}

	public function debug($a, $b = null) {
		if (!is_string($a)) {
			$a = json_encode($a);
		}

		if ($b) {
			if (!is_string($b)) {
				$b = json_encode($b);
			}

			if (empty($this->debug[$a])) {
				$this->debug[$a] = array();
			}

			if ($a == 'status' || $a == 'error') {
				$this->debug[$a] = $b;
			} else {
				$this->debug[$a][] = $b;
			}

			return;
		}

		$this->debug[] = $b;
	}

/**
 * Extract Package
 *
 * Extract the package to the path specified or the default if not specified.
 *
 * @return void
 **/
	public function extractPackage() {
		if ($this->settings['os'] == 'win' || !$this->settings['passthru']) {
			$this->debug('process', 'Manual Extracting');
			$this->manualExtract();
		} else {
			$this->debug('process', 'Auto Extracting');
			$this->autoExtract();
		}
		// @unlink($this->settings['path_to_file']);
		return true;
	}

/**
 * Auto Extraction
 *
 * Passthru works so we can run a command on the server to extract the files.
 *
 * @return void
 **/
	public function autoExtract() {
		$options = null;
		if ($this->settings['file_ext'] == 'tar') {
			$options = 'xf';
		} elseif ($this->settings['file_ext'] == 'tgz') {
			$options = 'xzf';
		} else {
			$this->debug('error', 'The installation file extension not compatible with extraction process.');
			$this->debug('extra', dirname(__FILE__) . '/' . $this->settings['filename']);
			$this->errorDie();
		}
		$command = 'tar -C ' . escapeshellarg(dirname(__FILE__)) . ' -v --no-same-owner -' . escapeshellarg($options) . ' ' . escapeshellarg($this->settings['path_to_file']);
		$this->settings['command'] = $command;

		$this->debug('Extracting with: ' . $command);

		$result = $this->runCommand($command);

		if (!$result) {
			$this->debug('error', 'Could not extract the package contents onto your server.');
			$this->errorDie();
		}

		$this->settings['list'] = explode("\n", $result);
		$this->debug('tar_output', $this->settings['list']);
		return true;
	}

/**
 * Manual Extract
 *
 * Extraction for windows machines
 *
 * @return void
 **/
	public function manualExtract() {
		$filename = $this->settings['path_to_file'];
		$returnValue = array();
		// Convert from tgz to tar
		if ($this->settings['file_ext'] == 'tgz') {
			$ghandle = gzopen($filename, 'r');
			$filename .= '.gzconvert';
			$reghandle = fopen($filename, 'w');
			gzseek($ghandle, 0);
			while ($temp = gzread($ghandle, 1048576)) {
				fwrite($reghandle, $temp);
			}
			fclose($reghandle);
			gzclose($ghandle);
		}
		$tarfile = @fopen($filename, 'r');
		$thetar = @fopen($filename, 'r');
		$longlinkfound = false;
		while (!feof($tarfile)) {
			$readdata = fread($tarfile, 512);
			if (substr($readdata, 257, 5) == 'ustar') {
				$tfilename = substr($readdata, 0, 100);
				$permissions = substr($readdata, 100, 8);
				$tfilename = dirname(__FILE__) . '/' . trim($tfilename);
				$indicator = substr($readdata, 156, 1);
				if ($indicator == 2) {
					$linklocation = dirname(__FILE__) . '/' . substr($readdata, 157, 100);
				}
				$offset = ftell($tarfile);
				$filesize = octdec(substr($readdata, 124, 12));
				$directory = "";
				if ($indicator == 5) {
					// Directory
					$levels = explode("/", $tfilename);
					$thestring = "";
					foreach ($levels as $level) {
						if ($level == '.') {
							continue;
						}
						$thestring .= $level . "/";
						$this->mkdir($thestring, 0755, true);
					}
					continue;
				}
				if ($indicator == 2) {
					symlink($linklocation, $tfilename);
					continue;
				}
				if ($longlinkfound) {
					$tfilename = dirname(__FILE__) . '/' . $longlinkfound;
				}
				if ($tfilename == dirname(__FILE__) . '/' . '././@LongLink') {
					fseek($thetar, $offset);
					$data = @fread($thetar, $filesize);
					$longlinkfound = $data;
					continue;
				} elseif ($longlinkfound) {
					$longlinkfound = false;
				}
				// Extract the file contents from the archive
				$fh = @fopen($tfilename, 'wb');
				fseek($thetar, $offset);
				$data = @fread($thetar, $filesize);
				$st = @fwrite($fh, $data);
				@fclose($fh);

				// Set permissions (if needed)
				if ($this->settings['os'] != 'WIN') {
					@chmod($tfilename, 0 . octdec(substr($permissions, 3)));
				}
			}
		}
		@fclose($thetar);
		@fclose($tarfile);
		// Remove temporary conversion file
		unlink( $filename );
		return true;
	}

/**
 * Set Permissions
 *
 * Set the file / directory permissions.
 *
 * @return void
 **/
	public function setPermissions() {
		if (!function_exists('chmod')) {
			return true;
		}

		foreach ($this->settings['list'] as $file) {
			@chmod($file, 0755);
		}

		return true;
	}

/**
 * mkdir replacement
 *
 * Recursive directory creation fails if at any point an
 * implicit is_dir fails when exploring the tree.  The problem
 * being, that is_dir sometimes fails on CIFS (Windows Samba
 * mounts) when there are a large number of inodes.  When that
 * returns false, mkdir tries to create that directory in the
 * path, but the mkdir also fails because the directory does
 * in fact exist.  chdir, stat, file_exists, etc., also all
 * fail.  But if you try to create a directory inside of the
 * unreadable directory it will succeed - so we need to find
 * our way past that if we can before reporting failure.
 *
 * @param  string $dir
 * @param  octet  $mode
 * @param  bool   $recursive
 * @return bool
 **/
	public function mkdir($dir, $mode = 0777, $recursive = true) {
		if (@mkdir( $dir, $mode, $recursive )) {
			return true;
		} else {
			// Looks like we failed.  Chances are the first place we
			// couldn't read was the site root itself, so try to make
			// the first directory under that as a starting point.

			// First, standardize paths.
			$root = implode( DIRECTORY_SEPARATOR, preg_split( '{[/\\\\]}', dirname(__FILE__) ) );
			$path = implode( DIRECTORY_SEPARATOR, preg_split( '{[/\\\\]}', $dir ) );

			// Find only those path elements which immediately follow
			// the root, and see if we can create that directory first.
			if (!strpos( $path, $root) === 0) {
				// Doesn't look like one is in the other, bail out.
				return false;
			}

			// Get the first path element following the site root.
			$pathParts = array_filter(
				preg_split(
					'{[/\\\\]}',
					substr( $path, strlen( $root ) )
				)
			);
			if (!$pathParts || !count( $pathParts)) {
				false;
			}

			$firstPath = $root . ( !preg_match( '{[/\\\\]$}', $root ) ? DIRECTORY_SEPARATOR : '' ) . array_shift( $pathParts );
			// This attempt must be false, or it will fail just like the
			// initial one above.
			if (@mkdir( $firstPath, $mode, false )) {
				if ($recursive) {
					if (count( $pathParts )) {
						// Should be OK to resume trying from here.
						return @mkdir( $path, $mode, $recursive );
					} else {
						// Created all there is to create, return true.
						return true;
					}
				} elseif (implode( '', $pathParts )) {
					// Gave us a recursive path but were told non-recursive?
					return false;
				} else {
					return true;
				}
			}
		}
		return false;
	}
/**
 * Set PHP Directives.
 *
 * Turns on the most basic requirements to allow PHP script execution
 * on vDeck, which only really matters if the package includes a php.ini
 * file to begin with, as this overwrites the default server settings
 * which allow it to function in the first place.
 *
 * @return void
 * @author Paul Tomlinson
 **/
	public function setPhpDirectives() {
		// New ini settings exisiting ini settings and preferred settings
		$phpIniFile = dirname(__FILE__) . '/' . 'php.ini';
		$preferredSettings = array(
			'cgi.force_redirect' => 'Off',
			'register_globals' => 'Off',
			'allow_url_fopen' => 'Off',
		);

		$deprecatedSettings = array(
			'5.3.0' => array(
				'define_syslog_variables',
				'register_globals',
				'register_long_arrays',
				'safe_mode',
				'magic_quotes_gpc',
				'magic_quotes_runtime',
				'magic_quotes_sybase',
			)
		);

		// Only need to amend existing INI files, not create new ones.
		if (file_exists( $phpIniFile )) {
			$systemIniSettings = array();
			$existingIniSettings = array();

			// get the default INI settings
			$settings = ini_get_all();
			foreach ($settings as $setting => $details) {
				$setting = trim($setting);
				if (empty($setting)) {
					continue;
				}
				$systemIniSettings[$setting] = $details['local_value'];
			}

			// merge the existing INI into defaults
			$existingSettings = @parse_ini_file( $phpIniFile );
			if (!$existingSettings) {
				$existingSettings = array();
				$file = fopen( $phpIniFile, 'r' );
				while ($line = fgets( $file )) {
					$line = trim( $line );
					if (empty( $line ) || strpos( $line, ';' ) === 0 || !strpos( $line, '=' )) {
						continue;
					}
					$setting = explode( '=', $line, 2 );
					if (count( $setting ) != 2) {
						continue; // Malformatted
					}
					$setting[0] = trim( $setting[0] );
					$setting[1] = trim( trim( $setting[1] ), '"' );
					if (!$setting[0]) {
						continue;
					}
					$existingSettings[$setting[0]] = $setting[1];
				}
			}
			$preferredSettings = array_merge(
				$existingSettings,
				$preferredSettings
			);

			$preferredSettings = array_merge($systemIniSettings, $preferredSettings);
			// Remove version-deprecations to avoid errors and warnings.
			foreach ($deprecatedSettings as $version => $deprecations) {
				if (version_compare( PHP_VERSION, $version, '>=' )) {
					foreach ($deprecations as $deprecated) {
						if (isset( $preferredSettings[$deprecated] )) {
							unset( $preferredSettings[$deprecated] );
						}
					}
				}
			}
			$lines = array();
			foreach ($preferredSettings as $setting => $value) {
				// If the merge has resulted in multiple conflicting settings, take
				// the last one as the preferred value.
				if (is_array( $value )) {
					$value = array_pop( $value );
				}
				$setting = trim($setting);
				if (empty($setting)) {
					continue;
				}
				$value = trim( trim($value), '"' );
				$quote = ( !preg_match( '/^[A-Za-z0-9_\\.\\-]+$/', $value ) ? '"' : '' );
				$lines[] = $setting . ' = ' . $quote . $value . $quote;
			}
			// Replace file with our updated version.
			file_put_contents( $phpIniFile, implode( PHP_EOL, $lines ) . PHP_EOL );
		}
	}

/**
 * Run Command
 *
 * Run the specified command using passthru to get and return the results.
 *
 * @param string $command The command to run on the server.
 * @return string $output The raw output of the command.
 **/
	public function runCommand($command = null, $redirect = false) {
		if (!$command) {
			return false;
		}

		$descriptorSpec = Array(
			Array('pipe', 'r'),
			Array('pipe', 'w'),
			Array('pipe', 'w')
		);

		$pipes = Array();
		$stdout = '';
		$stderr = '';

		$process = proc_open($command, $descriptorSpec, $pipes);

		if (!is_resource($process)) {
			$this->debug('Failed to open process for command ' . $command);
			return false;
		}

		// Keep reads from hanging
		stream_set_blocking($pipes[0], 0);
		stream_set_blocking($pipes[1], 0);
		stream_set_blocking($pipes[2], 0);

		$loops = 0;

		$ttl = 600;

		while (1) {
			$loops += 1;

			// This used to be fancy with stream_select, but it turns out that
			// stream_select doesn't block even when I want it to.  :/
			sleep(1);

			while ($moreStdout = stream_get_contents($pipes[1])) {
				$stdout .= $moreStdout;
			}

			while ($moreStderr = stream_get_contents($pipes[2])) {
				$stderr .= $moreStderr;
			}

			$status = proc_get_status($process);

			if (!$status['running']) {
				break;
			}

			if ($loops > $ttl) {
				$this->debug("terminating with 15 due to timeout at $loops loops");
				proc_terminate($process, 15);
				$status['exitcode'] = '15';
			}

			if ($loops > 5 + $ttl) {
				$this->debug("terminating with 9 due to timeout at $loops loops");
				proc_terminate($process, 9);
				$status['exitcode'] = '9';
			}
		}

		$exitCode = $status['exitcode'];

		$this->debug(compact('command', 'stdout', 'stderr', 'exitCode', 'loops'));

		// if ($exitCode) {
		// 	return false;
		// }

		return $stdout;
	}

	public function moveOldConfiguration() {
		if (empty($this->settings['old_configuration_locations'])) {
			$this->debug('process', 'old configuration locations is empty');
			return;
		}

		$locations = $this->settings['old_configuration_locations'];

		if (is_string($locations)) {
			$locations = json_decode($locations, true);
			if (!$locations) {
				$locations = json_decode(stripslashes($locations));
			}

			if (!$locations) {
				$this->debug('process', 'Could not parse old configuration locations ' . json_encode($this->settings['old_configuration_locations']));
			}

			$this->debug('process', 'Parsed locations...  Maybe.');
		}

		$this->debug('process', Array('trying to move aside old config files ' => $locations));

		foreach ($locations as $configLocation) {
			$path = trim($configLocation, '/');

			if (empty($path)) {
				return;
			}

			$path = '/' . trim(dirname(__FILE__), '/') . '/' . $path;

			$glob = $path;

			$this->debug('process', 'examining path ' . $path);

			foreach (glob($glob) as $path) {
				$this->debug('process', 'looking to move path ' . $path);

				if (stristr($path, '..')) {
					continue;
				}

				if (! (file_exists($path) || is_dir($path))) {
					$this->debug('process', 'didn\'t find ' . $path);
					continue;
				}

				$dirName = dirname($path);
				$pathName = basename($path);

				$newPath = $dirName . '/backup-' . time() . '-' . $pathName;

				$this->debug('process', 'moving ' . $path . ' to ' . $newPath);

				@rename($path, $newPath);
			}
		}
	}

/**
 * Error
 *
 * Call an error to pass back to the caller.
 *
 * @return void
 *
 **/
	public function errorDie() {
		$this->error['status'] = 'error';
		$this->error['debug'] = $this->debug;
		echo json_encode($this->error);
		$this->cleanShutdown = true;
		exit;
	}
}
